import { readdirSync } from 'fs'
import { execSync } from 'child_process'
import { config } from '../config'
import ora from 'ora'

export function serve() {
  const functions = readdirSync(config.functionsDir).filter((f) =>
    f.endsWith('.ts')
  )

  for (const functionFile of functions) {
    const functionName = functionFile.replace('.ts', '')
    ora().succeed(`Serving ${functionName}`)
    execSync(
      `npx functions-framework --source=${config.buildDir}/${functionName} --target=${functionName}`
    )
  }
}
